<template>
  <div id="open_space_table_subject_wrapper">
		<div>
			<div class="hotSubject">
				<div>
					<el-table
				  	:data="value"
						empty-text="해당 분야의 주제가 없습니다."
						:default-sort = "{prop: 'rate', order: 'descending'}"
						:height="height">
						<el-table-column label="#" fixed width="50">
							<template slot-scope="scope">
    				    {{ scope.$index + 1 }}
    				  </template>
						</el-table-column>
						<el-table-column label="소속" prop="affiliation_description.description" sortable></el-table-column>
						<el-table-column label="알림" prop="affiliation_description.description" sortable>
							<template slot-scope="scope">
								<!-- TODO. Follow 하지 않고있으면 Primary,  -->
								<el-button v-if="scope.row.isFollow === 0" @click="followAffiliation(scope.row)" type="primary" icon="el-icon-bell">알림받기</el-button>
								<el-button v-if="scope.row.isFollow === 1" @click="unfollowAffiliation(scope.row)" type="danger" icon="el-icon-bell">알림해제</el-button>								
							</template>
						</el-table-column>
						<!-- 버튼으로 만들어서 현재 접속한 학생이 알림 받고있는지 여부에 따라 다르게 표시해줘야 한다 -->
						<el-table-column label="주제명" prop="class.name" sortable></el-table-column>
						<el-table-column label="강습자명" prop="class.master.name" sortable></el-table-column>
						<el-table-column :label="$t('ENROLL_TABLE.RATE')" prop="rate" sortable width="160">
    				  		<template slot-scope="scope">
    				    		<el-rate v-model="scope.row.rate" disabled show-score></el-rate>
    				  		</template>
						</el-table-column>
						<el-table-column fixed="right" label="" width="120">
							<template slot-scope="scope">
								<el-button @click="showClass(scope.row)" type="text">입장</el-button>
							</template>
						</el-table-column>
					</el-table>
				</div>
			</div>
		</div>
  </div>
</template>

<script>
import openspaceService from '../../services/openspaceService';
import utils from '../../utils'; 

export default {
	name: 'OpenSpaceTableSubject',
  props: {
    value: Array,
    height: {
      type: Number
    }
	},
  methods: {
		async showClass(scope) {			
			const vm = this;
			// 클릭 로그 (입장로그)
			const res = await openspaceService.postOpenInstitutionUserClass({
      	classId: scope.class_id
			});
			vm.$router.push(`/a/student/NNclass/${scope.class_id}`);
		},
		// 2021-05-10 기관 Follow (알람받기)
		async followAffiliation(scope){						
			const vm = this;
			const res = await openspaceService.postAffiliationFollow({
				affiliationId: scope.affiliation_id,
				userId: utils.getUserIdFromJwt(),
			});
			scope.isFollow = 1;
			const notiMsg = "[" + scope.affiliation_description.description + "]의 알림을 등록하였습니다." 			
			vm.$notify({
				title: vm.$t("기관 알림"),
				message: vm.$t(notiMsg),
				type: "success",
				duration: 2000,
          	});
		},
		// 2021-05-10 기관 UnFollow (알람해제)
		async unfollowAffiliation(scope){			
			const vm = this;
			const res = await openspaceService.deleteAffiliationFollow({
				affiliationId: scope.affiliation_id,
				userId: utils.getUserIdFromJwt(),
			});
			scope.isFollow = 0;
			const notiMsg = "[" + scope.affiliation_description.description + "]의 알림을 해제하였습니다." 			
			vm.$notify({
				title: vm.$t("기관 알림"),				
				message: vm.$t(notiMsg),
				type: "success",
				duration: 2000,
          	});
		},		
  },
};
</script>         

<style lang="scss" scoped>
#open_space_table_subject_wrapper {
	.hotSubject{
		margin: 5px 50px 10px 50px
	}
}

</style>
